
#include <SPI.h>
#include <OneWire.h>
#include <Wire.h>


#include "DHT.h"
#include "BMP085.h"

BMP085 dps = BMP085();
long Pressure085 = 0;

#define DHTTYPE DHT11   // DHT 11 
DHT dht(8, DHTTYPE);

OneWire  ds(7);  // on pin 7

byte my_addr[8]={0x28,0xB0,0x16,0xB8,3,0,0,0x90};



void setup() {
  Serial.begin(9600);
  Wire.begin();
  dps.init();   
}


void loop () 
 {
   
  if (Serial.available()>0)
    {
    if(Serial.read()=='1')
      {
      int Temp=get_temp();
      Serial.print("#28B016B803000090#");
      Serial.print(Temp/16);
      Serial.print(".");
      Serial.print(abs((Temp%16)*100)/16);
      Serial.print("&");
      float h = dht.readHumidity();
      Serial.print("#29B016B803000090#"); 
      Serial.print(h);
      Serial.print("&");
      Serial.print("#30B016B803000090#"); 
      dps.getPressure(&Pressure085);
      Serial.print(Pressure085/133.3); 
      Serial.print("&");
     } 
   }  

 
 }
// получение тмпературы датчика
int get_temp()
 {
byte i;
byte present = 0;
byte data[12];
byte addr[8];
int Temp;
  
  /*if ( !ds.search(addr)) {
        //Serial.print("No more addresses.\n");
        ds.reset_search();
        return 0;
  }
  Serial.print("R=");  //R=28 Not sure what this is
  for( i = 0; i < 8; i++) {
    Serial.print(addr[i], HEX);
    Serial.print(" ");
  }
  if ( OneWire::crc8( addr, 7) != addr[7]) {
        Serial.print("CRC is not valid!\n");
        return 0;
  }
  if ( addr[0] != 0x28) {
        Serial.print("Device is not a DS18S20 family device.\n");
        return 0;
  }
  */
  ds.reset();
  ds.select(my_addr);
  ds.write(0x44,1);        // start conversion, with parasite power on at the end
  delay(1000);     // maybe 750ms is enough, maybe not
  // we might do a ds.depower() here, but the reset will take care of it.
  
  present = ds.reset();
  ds.select(my_addr);
  ds.write(0xBE);          // Read Scratchpad
  for ( i = 0; i < 9; i++) {         // we need 9 bytes
    data[i] = ds.read();
  }
  Temp=(data[1]<<8)+data[0];//take the two bytes from the response relating to temperature

  Temp=Temp;//divide by 16 to get pure celcius readout
  
  return Temp;
 }
 

